unit MainForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, GPXYGraph, GPXYSeries,
  Vcl.ComCtrls, Vcl.StdCtrls, Math;

type
  TForm1 = class(TForm)
    TrackBar1: TTrackBar;
    GPXYGraph1: TGPXYGraph;
    Series1: TXYMarkerSeries;
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    { Private 錾 }
    P: double;
  public
    { Public 錾 }
    procedure FillValues(Series: TGPXYGraphSeries);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FillValues(Series: TGPXYGraphSeries);
var
  I: Integer;
  X, Y: double;
begin
  Series.Clear;
  Series.BeginUpdate;
  try
    for i := 0 to 50 do
    begin
      X := 4*Pi*I/50;
      Y := sin(P*X)+cos(x);
      Series.AddXY(X, Y);
    end;
  finally
    Series.EndUpdate;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  GPXYGraph1.XAxis.SetMinMax(0, 4 * Pi);
  GpXYGraph1.YAxis.SetMinMax(-3, 3);
  FillValues(Series1);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  P := 3 * TrackBar1.Position/TrackBar1.Max;
  FillValues(Series1);
end;

end.
