{

                          @copyright   S. Sekine  }

unit GPXYGraphDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Spin, ExtCtrls, Buttons, Vcl.Grids,
  Winapi.GDIPAPI, Winapi.GDIPOBJ,
  GPXYGraph, GPXYSeries, GPXYSeriesDlg, ColorPicker;

type
  TGraphEditDlg = class(TForm)
    EditPageCtrl: TPageControl;
    GraphSheet: TTabSheet;
    DataSheet: TTabSheet;
    AxisSheet: TTabSheet;
    GraphSub: TPageControl;
    GraphSeriesSheet: TTabSheet;
    GraphGeneralSheet: TTabSheet;
    UpSpeedButton: TSpeedButton;
    DownSpeedButton: TSpeedButton;
    DeleteSeriesButton: TButton;
    AddSeriesButton: TButton;
    SeriesListBox: TListBox;
    GraphTitleSheet: TTabSheet;
    SeriesPanel: TPanel;
    SeriesCalssLabel: TLabel;
    SeriesComboBox: TComboBox;
    SeriesSubPage: TPageControl;
    SeriesLineSheet: TTabSheet;
    SeriesFillSheet: TTabSheet;
    SeriesMarkerSheet: TTabSheet;
    SeriesArrowSheet: TTabSheet;
    VisiblePanel: TPanel;
    AxesSelectGroup: TRadioGroup;
    AxisVisibleCheck: TCheckBox;
    AxisSubPage: TPageControl;
    AxisRangeSheet: TTabSheet;
    AxisLabelSheet: TTabSheet;
    AxisTitleSheet: TTabSheet;
    AxisTicksSheet: TTabSheet;
    AspectRatioGroup: TGroupBox;
    AutoAspectRatioCheck: TCheckBox;
    FrameGroup: TGroupBox;
    GraphFrameCheck: TCheckBox;
    ColorGroup: TGroupBox;
    Label13: TLabel;
    Label14: TLabel;
    GraphAreaColorPicker: TColorPickButton;
    PlotAreaColorPicker: TColorPickButton;
    TitlePosGroup: TRadioGroup;
    TitleEdit: TMemo;
    Label17: TLabel;
    PiSymbolEdit: TEdit;
    TitleFontBtn: TButton;
    LineStyleGroupBox: TGroupBox;
    LabelLWidth: TLabel;
    LabelLKind: TLabel;
    LabelLineWidth: TLabel;
    LineColorPicker: TColorPickButton;
    LabelLineColor: TLabel;
    LineStyleComboBox: TComboBox;
    LineWidthTrackBar: TTrackBar;
    LineDisContinueCheck: TCheckBox;
    FillStyleRadioGroup: TRadioGroup;
    FillColorGroupBox: TGroupBox;
    LabelTransparent: TLabel;
    FillColorPicker: TColorPickButton;
    FillTransparentTrackBar: TTrackBar;
    FillPatternPanel: TPanel;
    LabelForeColor: TLabel;
    LabelBackColor: TLabel;
    LabelPatternGrid: TLabel;
    FillForeColorPicker: TColorPickButton;
    FillBackColorPicker: TColorPickButton;
    PatternDrawGrid: TDrawGrid;
    GroupBox7: TGroupBox;
    Label18: TLabel;
    Label19: TLabel;
    LabelMarkerColor: TLabel;
    MarkerColorPicker: TColorPickButton;
    MarkerActiveCheck: TCheckBox;
    MarkerShapeComboBox: TComboBox;
    MarkerSizeEdit: TSpinEdit;
    MarkerJoinedCheck: TCheckBox;
    ArrowActiveCheck: TCheckBox;
    ArrowActiveLabel: TLabel;
    ArrowSizeEdit: TSpinEdit;
    BottomPanel: TPanel;
    FontDialog: TFontDialog;
    CloseBtn: TButton;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    LabelValueAuto: TLabel;
    AxisMinCheck: TCheckBox;
    AxisMinEdit: TEdit;
    AxisMaxEdit: TEdit;
    AxisMaxCheck: TCheckBox;
    AxisStepCheck: TCheckBox;
    AxisStepEdit: TEdit;
    AxisOriginEdit: TEdit;
    AxisOriginCheck: TCheckBox;
    AxisSubTicksCountEdit: TSpinEdit;
    AxisScaleCombo: TComboBox;
    AxisInverseCheck: TCheckBox;
    GroupBox3: TGroupBox;
    Label8: TLabel;
    Label5: TLabel;
    Label24: TLabel;
    AxisLabelVisibleCheck: TCheckBox;
    AxisLabelOnAxisCheck: TCheckBox;
    AxisAutoDecimalCheck: TCheckBox;
    AxisLabelFontBtn: TButton;
    AxisLabelDecEdit: TSpinEdit;
    AxisTicksCountEdit: TSpinEdit;
    AxisLabelSpaceEdit: TSpinEdit;
    GroupBox5: TGroupBox;
    Label9: TLabel;
    Label27: TLabel;
    Label7: TLabel;
    AxisTitleEdit: TEdit;
    AxisTitleLocCombo: TComboBox;
    AxisTitleAngleCombo: TComboBox;
    AxisTitleFontBtn: TButton;
    GroupBox4: TGroupBox;
    Label11: TLabel;
    Label12: TLabel;
    Label6: TLabel;
    AxisTickLenEdit: TSpinEdit;
    AxisSubTickLenEdit: TSpinEdit;
    AxisExtraLenEdit: TSpinEdit;
    AxisFomatSheet: TTabSheet;
    AxisLineGroupBox: TGroupBox;
    Label1: TLabel;
    Label4: TLabel;
    LabelAxisWidth: TLabel;
    AxisLineColorPicker: TColorPickButton;
    Label15: TLabel;
    AxisLineComboBox: TComboBox;
    AxisLineTrackBar: TTrackBar;
    GridlineSheet: TTabSheet;
    GrodlineSubPage: TPageControl;
    GridlineKindSheet: TTabSheet;
    GridlineFormatSheet: TTabSheet;
    GridlineKindGroup: TGroupBox;
    BothGridButton: TSpeedButton;
    HrznGridButton: TSpeedButton;
    VertGridButton: TSpeedButton;
    NoGridButton: TSpeedButton;
    SubGridCheck: TCheckBox;
    GridlineGroupBox: TGroupBox;
    Label10: TLabel;
    Label16: TLabel;
    LabelGridlineWidth: TLabel;
    GridlineColorPicker: TColorPickButton;
    Label21: TLabel;
    GridlineComboBox: TComboBox;
    GridlineTrackBar: TTrackBar;
    GridlineSelectGroup: TRadioGroup;
    EditSeriesButton: TButton;
    procedure AxisVisibleCheckClick(Sender: TObject);
    procedure AxisTitleFontBtnClick(Sender: TObject);
    procedure AxisMinCheckClick(Sender: TObject);
    procedure AxisMaxCheckClick(Sender: TObject);
    procedure AxisStepCheckClick(Sender: TObject);
    procedure AxisInverseCheckClick(Sender: TObject);
    procedure AxisSubTicksCountEditChange(Sender: TObject);
    procedure AxisLabelVisibleCheckClick(Sender: TObject);
    procedure AxisLabelOnAxisCheckClick(Sender: TObject);
    procedure AxisLabelDecEditChange(Sender: TObject);
    procedure AxisLabelFontBtnClick(Sender: TObject);
    procedure AxisMinEditExit(Sender: TObject);
    procedure AxisMaxEditExit(Sender: TObject);
    procedure AxisStepEditExit(Sender: TObject);
    procedure AxisTitleEditChange(Sender: TObject);
    procedure AxisMinEditEnter(Sender: TObject);
    procedure AxisMaxEditEnter(Sender: TObject);
    procedure AxisStepEditEnter(Sender: TObject);
    procedure TitleFontBtnClick(Sender: TObject);
    procedure TitleEditChange(Sender: TObject);
    procedure TitlePosGroupClick(Sender: TObject);
    procedure AxisAutoDecimalCheckClick(Sender: TObject);
    procedure PiSymbolEditChange(Sender: TObject);
    procedure PiSymbolBtnClick(Sender: TObject);
    procedure AxisScaleComboChange(Sender: TObject);
    procedure AxisTitleLocComboChange(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure SeriesComboBoxChange(Sender: TObject);
    procedure AxisLabelSpaceEditChange(Sender: TObject);
    procedure AxesSelectGroupClick(Sender: TObject);
    procedure AxisOriginCheckClick(Sender: TObject);
    procedure AxisOriginEditEnter(Sender: TObject);
    procedure AxisOriginEditExit(Sender: TObject);
    procedure AxisTitleAngleComboChange(Sender: TObject);
    procedure AxisTickLenEditChange(Sender: TObject);
    procedure AxisSubTickLenEditChange(Sender: TObject);
    procedure AutoAspectRatioCheckClick(Sender: TObject);
    procedure BothGridButtonClick(Sender: TObject);
    procedure HrznGridButtonClick(Sender: TObject);
    procedure VertGridButtonClick(Sender: TObject);
    procedure NoGridButtonClick(Sender: TObject);
    procedure SubGridCheckClick(Sender: TObject);
    procedure AxisTicksCountEditChange(Sender: TObject);
    procedure AxisExtraLenEditChange(Sender: TObject);
    procedure FillStyleRadioGroupClick(Sender: TObject);
    procedure PatternDrawGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormCreate(Sender: TObject);
    procedure LineWidthTrackBarChange(Sender: TObject);
    procedure MarkerActiveCheckClick(Sender: TObject);
    procedure MarkerShapeComboBoxChange(Sender: TObject);
    procedure MarkerSizeEditChange(Sender: TObject);
    procedure MarkerJoinedCheckClick(Sender: TObject);
    //procedure ColoringRadioGroupClick(Sender: TObject);
    //procedure ColoringMapKindComboSelect(Sender: TObject);
    procedure FillTransparentTrackBarChange(Sender: TObject);
    procedure PatternDrawGridClick(Sender: TObject);
    procedure LineStyleComboBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure LineDisContinueCheckClick(Sender: TObject);
    //procedure LineRadioGroupClick(Sender: TObject);
    procedure LineStyleComboBoxSelect(Sender: TObject);
    procedure ArrowSizeEditChange(Sender: TObject);
    procedure ArrowActiveCheckClick(Sender: TObject);
    procedure LineColorPickerSelect(Sender: TObject);
    procedure GridlineSelectGroupClick(Sender: TObject);
    procedure AxisLineComboBoxSelect(Sender: TObject);
    procedure AxisLineTrackBarChange(Sender: TObject);
    procedure AxisLineColorPickerSelect(Sender: TObject);
    procedure MarkerColorPickerSelect(Sender: TObject);
    //procedure ColoringStartColorPickerSelect(Sender: TObject);
    //procedure ColoringEndColorPickerSelect(Sender: TObject);
    procedure FillColorPickerSelect(Sender: TObject);
    procedure FillBackColorPickerSelect(Sender: TObject);
    procedure FillForeColorPickerSelect(Sender: TObject);
    procedure GraphAreaColorPickerSelect(Sender: TObject);
    procedure PlotAreaColorPickerSelect(Sender: TObject);
    procedure GraphFrameCheckClick(Sender: TObject);
    procedure AddSeriesButtonClick(Sender: TObject);
    procedure DeleteSeriesButtonClick(Sender: TObject);
    procedure DownButtonClick(Sender: TObject);
    procedure UpButtonClick(Sender: TObject);
    procedure SeriesListBoxClick(Sender: TObject);
    procedure SeriesListBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure EditSeriesButtonClick(Sender: TObject);
    //procedure GraphSubChange(Sender: TObject);
    procedure AxisSubTicksCountEditClick(Sender: TObject);
    procedure GridlineColorPickerSelect(Sender: TObject);
    procedure GridlineTrackBarChange(Sender: TObject);
    procedure GridlineComboBoxSelect(Sender: TObject);
  private
    { Private 錾 }
    CurrAxis: TGPGraphAxis;
    CurrPen: TPen;
    CurrAxisIndex: integer;
    CurrGridLineIndex: integer;
    SelectedSeries: TGPXYGraphSeries;  //폜A̕ύX̂߂ɑIꂽn
    EditGraph: TGPXYGraph;
    TempText: string;
    PatternForeColor: TGPColor;
    PatternBackColor: TGPColor;
    procedure AxisSettings;
    procedure GraphSeriesSheetSetting;
    procedure GraphSettings;
    procedure InitSettings;
    procedure SetupSeriesComboBox;
    procedure UpdateSeriesSubPage;
    procedure MarkerSettings;
    //procedure ColoringSettings;
    procedure FillStyleSettings;
    procedure LineStyleSettings;
    procedure ArrowSettings;
    procedure AxisLineSetting;
    procedure GridlineSetting;
    //procedure AdjustColoringCategoryPanel;
    //procedure AdjustFillStylePanel;
    procedure SetGraph(Value: TGPXYGraph);
    procedure UpdateAxisScale;
    function GetCurrGridlinePen(Index: Integer): TPen;
    function GetCurrAxisPen(Index: Integer): TPen;
  public
    { Public 錾 }
    property Graph: TGPXYGraph read EditGraph write SetGraph;
  end;

implementation

{$R *.DFM}
{$R *.res}

procedure TGraphEditDlg.FormCreate(Sender: TObject);
begin
  PatternForeColor := aclBlack;
  PatternBackColor := aclWhite;
end;

procedure TGraphEditDlg.CloseBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TGraphEditDlg.SetGraph(Value: TGPXYGraph);
begin
  EditGraph:=Value;
  AxesSelectGroup.ItemIndex := CurrAxisIndex;
  if CurrAxisIndex = 0 then
    CurrAxis := Graph.XAxis
  else
    CurrAxis := Graph.YAxis;
  InitSettings;
end;

procedure TGraphEditDlg.SeriesListBoxClick(Sender: TObject);
begin
  SelectedSeries := Graph.Series[SeriesListBox.ItemIndex];
  GraphSeriesSheetSetting;
  SeriesComboBox.ItemIndex := Graph.SeriesIndexOf(SelectedSeries);
  UpdateSeriesSubPage;
  //SeriesComboBoxChange(SeriesListBox);
end;

procedure TGraphEditDlg.GraphSeriesSheetSetting;
var
  i, Index: integer;
  S: string;
begin
  SeriesListBox.Items.BeginUpdate;
  try
    SeriesListBox.Clear;
    if Graph.SeriesCount > 0 then
    begin
      for i:=0 to Graph.SeriesCount-1 do
      begin
        S := Graph.Series[i].Name;
        if S = '' then
        begin
          S := 'Series' + IntToStr(i+1);
          Index := Pos('Series', S);
          Copy(S, Index, 10);
        end;
        SeriesListBox.Items.Add(S);
      end;
      if SelectedSeries = nil then
        SelectedSeries := Graph.Series[0];
      SeriesListBox.ItemIndex := Graph.SeriesIndexOf(SelectedSeries);
    end
    else
    begin
      SelectedSeries := nil;
    end;
  finally
    SeriesListBox.Items.EndUpdate;
  end;
  AddSeriesButton.Enabled := csDesigning in Graph.ComponentState;
  DeleteSeriesButton.Enabled := (csDesigning in Graph.ComponentState)
    and (SeriesListBox.ItemIndex > -1);
  UpSpeedButton.Enabled := SeriesListBox.ItemIndex > 0;
  DownSpeedButton.Enabled := (SeriesListBox.ItemIndex > -1)
    and (SeriesListBox.ItemIndex < SeriesListBox.Items.Count - 1);
  EditSeriesbutton.Enabled := SelectedSeries <> nil;
  SetupSeriesComboBox;
  SeriesComboBox.ItemIndex := SeriesListBox.ItemIndex;
end;

procedure TGraphEditDlg.UpButtonClick(Sender: TObject);
begin
  Graph.SeriesUp(Graph.Series[SeriesListBox.ItemIndex]);
  GraphSeriesSheetSetting;
end;

procedure TGraphEditDlg.DownButtonClick(Sender: TObject);
begin
  Graph.SeriesDown(Graph.Series[SeriesListBox.ItemIndex]);
  GraphSeriesSheetSetting;
end;

procedure TGraphEditDlg.EditSeriesButtonClick(Sender: TObject);
begin
  //Iꂽnuny[Wv\B
  EditPageCtrl.ActivePageIndex := 1;
end;

{f[^̍폜}
procedure TGraphEditDlg.DeleteSeriesButtonClick(Sender: TObject);
begin
  if (csDesigning in Graph.ComponentState) and (SelectedSeries <> nil) then
  begin
    if (MessageDlg(SelectedSeries.Name + '폜܂',
       mtConfirmation, [mbYes, mbNo], 0)) = mrYes then
    begin
      SelectedSeries.Free;
      SelectedSeries := nil;
      if Graph.SeriesCount = 0 then
      begin
        Graph.XAxis.ResetScale;
        Graph.YAxis.ResetScale;
      end;
      GraphSeriesSheetSetting;
    end;
  end;
end;

{f[^̒ǉ}
procedure TGraphEditDlg.AddSeriesButtonClick(Sender: TObject);
var
  NewSeries: TGPXYGraphSeries;
  SeriesSelectDlg: TSeriesSelectDlg;
  I, J: integer;
  S: string;
  InUse: boolean;
begin
  if not (csDesigning in Graph.ComponentState) then Exit;
  SeriesSelectDlg := TSeriesSelectDlg.Create(Self);
  try
    if SeriesSelectDlg.ShowModal = mrOK then
    begin
      with SeriesSelectDlg do
        NewSeries := SelectedSeriesClass.Create(Graph.Owner);
      NewSeries.ParentGraph:=Graph;

      I:=1;
      InUse := true;
      while InUse do
      begin
        S := Format('Series' + '%d', [I]);
        for J := 0 to NewSeries.Owner.ComponentCount-1 do
        begin
          InUse := CompareText(NewSeries.Owner.Components[J].Name, S) = 0;
          if InUse then break;
        end;
        Inc(I);
      end;
      NewSeries.Name := S;
      SelectedSeries := NewSeries;
    end;
  finally
    SeriesSelectDlg.Release;
  end;
  SeriesListBox.ItemIndex := Graph.SeriesIndexOf(SelectedSeries);
  GraphSeriesSheetSetting;
end;

procedure TGraphEditDlg.SeriesListBoxDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  Bitmap: TBitmap;
  L, T, H: Integer;
  Temp: TColor;
begin
  Bitmap := TBitmap.Create;
  try
    try
      Bitmap.LoadFromResourceName(hInstance, Graph.Series[Index].ClassName);
    except
      on EResNotFound do Bitmap.LoadFromResourceName(hInstance, 'TXYLineSeries');
    end;
    L := Rect.Left + 2;
    T := Rect.Top + 1;
    H := SeriesListBox.ItemHeight;
    with SeriesListBox do
    begin
      Canvas.Font := Font;
      Canvas.FillRect(Rect);
      Canvas.Draw(L, T, Bitmap);
      L := L + Bitmap.Width + 2;
      Temp := Canvas.Brush.Color;
      Canvas.Brush.Color := Graph.Series[Index].SeriesColor;
      Canvas.Rectangle(L, T+H div 2 -3, L+16, T+H div 2 +3);
      Canvas.Brush.Color := Temp;
      L := L+18;

      if odSelected in State then
        Canvas.Font.Color := $FFFFFF - ColorToRGB(Canvas.Font.Color);

      Rect.Left := L;
      Canvas.FillRect(Rect);
      Canvas.TextOut(L, T+H div 2 -Canvas.TextHeight('H') div 2, Items[Index]);
    end;
  finally
    Bitmap.Free;
  end;
end;

procedure TGraphEditDlg.InitSettings;
begin
  SelectedSeries := nil;
  GraphSeriesSheetSetting;
  AxisSettings;
  LineStyleSettings;
  FillStyleSettings;
  MarkerSettings;
  ArrowSettings;
  GraphSettings;
  AxisLineSetting;
  GridlineSetting;
end;

procedure TGraphEditDlg.UpdateAxisScale;
var
  Temp: double;
begin
  Graph.Update;
  with CurrAxis do
  begin
    //ől
    AxisMaxCheck.Checked:=AutoMax;
    if AxisScale = asPi then Temp := Max/Pi
    else Temp := Max;
    AxisMaxEdit.Text:=FloatToStr(Temp);
    //ŏl
    AxisMinCheck.Checked:=AutoMin;
    if AxisScale = asPi then Temp := Min/Pi
    else Temp := Min;
    AxisMinEdit.Text:=FloatToStr(Temp);
    //ڐԊu
    AxisStepCheck.Checked:=AutoStep;
    if AxisScale = asPi then Temp := TickStep/Pi
    else Temp := TickStep;
    AxisStepEdit.Text:=FloatToStr(Temp);
    //_
    AxisOriginCheck.Checked:=AutoOrigin;
    if AxisScale = asPi then Temp := Origin/Pi
    else Temp := Origin;
    AxisOriginEdit.Text :=FloatToStr(Temp);

    AxisTitleLocCombo.ItemIndex:=Ord(AxisTitleLoc);
    AxisLabelOnAxisCheck.Checked:=LabelsOnAxis;
    AxisSubTicksCountEdit.Enabled:=(AxisScale<>asLog);
    AxisStepEdit.Enabled:=(AxisScale<>asLog);
    AxisTickLenEdit.Value := TickLen;
    AxisSubTickLenEdit.Value := SubTickLen;
  end;
end;

procedure TGraphEditDlg.AxisSettings;
begin
  with CurrAxis do
  begin
    AxisVisibleCheck.Checked:=Visible;
    AxisTitleEdit.Text:=Title;
    AxisScaleCombo.ItemIndex:=Ord(AxisScale);
    AxisTitleAngleCombo.ItemIndex:=TitleAngle div 90;
    AxisInverseCheck.Checked:=Inverted;
    AxisTicksCountEdit.Value:=TicksCount;
    AxisSubTicksCountEdit.Value:=SubTicksCount;
    AxisLabelVisibleCheck.Checked:=Labels;
    AxisLabelDecEdit.Value:=LabelDecimal;
    AxisAutoDecimalCheck.Checked:=AutoDecimal;
  end;
  UpdateAxisScale;
end;

{n̐ݒy[W}
{SeriesSubPageɂV[gXV}
{̎葱́ASeriesComboBox̏ƍXVɌĂ΂}
procedure TGraphEditDlg.UpdateSeriesSubPage;
begin
  if SelectedSeries = nil then
    SeriesCalssLabel.Caption := ''
  else
    SeriesCalssLabel.Caption := SelectedSeries.GetSeriesTitle + 'n';

  LineStyleSettings;
  FillStyleSettings;
  MarkerSettings;
  ArrowSettings;
  SeriesFillSheet.TabVisible  := (SelectedSeries is TXYPolygonSeries);
  SeriesLineSheet.TabVisible := (SelectedSeries is TXYLineSeries);
  SeriesMarkerSheet.TabVisible := (SelectedSeries is TXYMarkerSeries);
  SeriesArrowSheet.TabVisible := (SelectedSeries is TXYArrowSeries);
end;

{SeriesComboBox ̐ݒ}
procedure TGraphEditDlg.SetupSeriesComboBox;
var
  i, Index: integer;
  S: string;
begin
  SeriesComboBox.Items.BeginUpdate;
  try
    SeriesCalssLabel.Caption := '';
    SeriesComboBox.Clear;
    if Graph.SeriesCount > 0 then
    begin
      for i:=0 to Graph.SeriesCount-1 do
      begin
        S := Graph.Series[i].Name;
        if S = '' then
        begin
          S := 'Series' + IntToStr(i+1);
          Index := Pos('Series', S);
          Copy(S, Index, 10);
        end;
        SeriesComboBox.Items.Add(S);
      end;
     // SeriesComboBox.ItemIndex := 0;
      if SelectedSeries = nil  then
        SelectedSeries := Graph.Series[0];
    end;
  finally
    SeriesComboBox.Items.EndUpdate;
  end;
  UpdateSeriesSubPage;
end;

procedure TGraphEditDlg.SeriesComboBoxChange(Sender: TObject);
var
  Index: Integer;
begin
  Index :=  SeriesComboBox.ItemIndex;
  if Index = -1 then
    SelectedSeries := nil
  else
    SelectedSeries := Graph.Series[Index];
  UpdateSeriesSubPage;
end;

{hԂV[g}
{hԂńATXYPolygonSeries̔hNX}
procedure TGraphEditDlg.FillStyleSettings;
var
  Series: TXYPolygonSeries;
  Index: Integer;
begin
  if SelectedSeries is TXYPolygonSeries then
  begin
    Series := SelectedSeries as TXYPolygonSeries;
    if Series.Brush.Style = bsClear then
    begin
      FillStyleRadioGroup.ItemIndex := 0;
      FillColorGroupBox.Visible := False;
      FillPatternPanel.Visible := False;
    end
    else if Series.Brush.Style = bsSolid then
    begin
      FillStyleRadioGroup.ItemIndex := 1;
      FillColorGroupBox.Visible := True;
      FillPatternPanel.Visible := False;
    end
    else
    begin
      FillStyleRadioGroup.ItemIndex := 2;
      FillColorGroupBox.Visible := False;
      FillPatternPanel.Visible := True;
    end;
    FillColorPicker.Selected := Series.FillForeColor;
    FillForeColorPicker.Selected := Series.FillForeColor;
    PatternForeColor := ColorRefToARGB(Series.FillForeColor );
    FillBackColorPicker.Selected := Series.FillBackColor;
    PatternBackColor := ColorRefToARGB(Series.FillBackColor );
    FillTransparentTrackBar.Position := Trunc((255 - Series.FillAlpha)/2.55);
    with PatternDrawGrid do
    begin
      Index := Integer(Series.HatchStyle);
      Row := Index div 6;
      Col := Index - 6 * Row;
      Invalidate;
    end;
  end;
end;

procedure TGraphEditDlg.FillStyleRadioGroupClick(Sender: TObject);
var
  Series: TXYPolygonSeries;
begin
  if (SelectedSeries is TXYPolygonSeries) then
  begin
    Series := SelectedSeries as TXYPolygonSeries;
    case FillStyleRadioGroup.ItemIndex of
      0: Series.Brush.Style := bsClear;
      1: Series.Brush.Style := bsSolid;
      2: Series.Brush.Style := bsCross;
    end;
    FillStyleSettings;
  end;
end;

procedure TGraphEditDlg.FillColorPickerSelect(Sender: TObject);
var
  Series: TXYPolygonSeries;
begin
  if (SelectedSeries is TXYPolygonSeries) then
  begin
    Series := SelectedSeries as TXYPolygonSeries;
    //Series.Brush.Style := bsSolid;
    Series.Brush.Color := FillColorPicker.Selected;
    Series.FillForeColor := FillColorPicker.Selected;
  end;
end;

{hԂF̓x̐ݒ}
procedure TGraphEditDlg.FillTransparentTrackBarChange(Sender: TObject);
var
  Series: TXYPolygonSeries;
  Temp: Integer;
begin
  if (SelectedSeries is TXYPolygonSeries) then
  begin
    Series := SelectedSeries as TXYPolygonSeries;
    with FillTransparentTrackBar do
    begin
      Temp := Trunc(2.55 * (Max - Position));
      Series.FillAlpha := Byte(Temp);
    end;
  end;
end;


procedure TGraphEditDlg.FillBackColorPickerSelect(Sender: TObject);
var
  Series: TXYPolygonSeries;
begin
  if (SelectedSeries is TXYPolygonSeries) then
  begin
    Series := SelectedSeries as TXYPolygonSeries;
    Series.FillBackColor := FillBackColorPicker.Selected;
    PatternBackColor := ColorRefToARGB(Series.FillBackColor );
    PatternDrawGrid.Invalidate;
  end;
end;

procedure TGraphEditDlg.FillForeColorPickerSelect(Sender: TObject);
var
  Series: TXYPolygonSeries;
begin
  if (SelectedSeries is TXYPolygonSeries) then
  begin
    Series := SelectedSeries as TXYPolygonSeries;
    Series.Brush.Style := bsCross;
    Series.FillForeColor := FillForeColorPicker.Selected;
    FillColorPicker.Selected := Series.FillForeColor;
    PatternForeColor := ColorRefToARGB(Series.FillForeColor );
    PatternDrawGrid.Invalidate;
  end;
end;

procedure TGraphEditDlg.PatternDrawGridClick(Sender: TObject);
var
  Series: TXYPolygonSeries;
begin
  if (SelectedSeries is TXYPolygonSeries) then
  begin
    Series := SelectedSeries as TXYPolygonSeries;
    Series.Brush.Style := bsCross;
    with PatternDrawGrid do
      Series.HatchStyle := THatchStyle(6 * Row + Col);
  end;
end;

procedure TGraphEditDlg.PatternDrawGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  GPGraphics: TGPGraphics;
  GPRect: TGPRect;
  Pen: TGPPen;
  Brush: TGPBrush;
  HBStyle: HatchStyle;
begin
  GPGraphics := TGPGraphics.Create(PatternDrawGrid.Canvas.Handle);
  HBStyle := HatchStyle(6 * Arow + ACol);//(Ord(Brush.Style));
  Pen := TGPPen.Create(aclWhiteSmoke, 2.0);
  if gdSelected in State then
    Pen.SetColor(aclGray);
  Brush := TGPHatchBrush.Create(HBStyle, PatternForeColor, PatternBackColor);
  try
    InflateRect(Rect, -1, -1);
    GPRect := MakeRect(Rect);
    GPGraphics.DrawRectangle(Pen, GPRect);
    GPGraphics.FillRectangle(Brush, GPRect);
  finally
    Brush.Free;
    Pen.Free;
    GPGraphics.Free;
  end;
end;


{n̐̐ݒ}

procedure TGraphEditDlg.LineStyleSettings;
var
  Series: TXYLineSeries;
  Value: Double;
begin
  if SelectedSeries is TXYLineSeries then
  begin
    Series := SelectedSeries as TXYLineSeries;
    LineDisContinueCheck.Checked := not Series.DisContinue;
    LineStyleComboBox.ItemIndex := Integer(Series.LinePen.Style) ;
    Value := 4 * Series.LineThickness -1;
    with LineWidthTrackBar do
    begin
      if Value > Max then Value := Max;
      if Value < Min then Value := Min;
      Position := Trunc(Value);
    end;
    LineColorPicker.Enabled := True;
    LineColorPicker.Selected := Series.SeriesColor;
    LineStyleComboBox.ItemIndex := Integer(Series.LinePen.Style);
  end;
end;

procedure TGraphEditDlg.LineColorPickerSelect(Sender: TObject);
var
  Series: TXYLineSeries;
begin
  if (SelectedSeries is TXYLineSeries) then
  begin
    Series := SelectedSeries as TXYLineSeries;
    Series.SeriesColor := LineColorPicker.Selected;
  end;
end;

procedure TGraphEditDlg.LineDisContinueCheckClick(Sender: TObject);
var
  Series: TXYLineSeries;
begin
  if (SelectedSeries is TXYLineSeries) then
  begin
    Series := SelectedSeries as TXYLineSeries;
    Series.DisContinue := not LineDisContinueCheck.Checked;
  end;
end;

procedure TGraphEditDlg.LineStyleComboBoxDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  Center: Integer;
begin
  with Control as TComboBox do
  begin
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top + 1, Items[Index]);
    Canvas.Pen.Style := TPenStyle(Index);
    Center := (Rect.Top  + Rect.Bottom) div 2;
    Canvas.MoveTo(Rect.Left + 12, Center);
    Canvas.LineTo(Rect.Right - 2, Center);
  end;
end;

procedure TGraphEditDlg.LineStyleComboBoxSelect(Sender: TObject);
var
  Series: TXYLineSeries;
begin
  if (SelectedSeries is TXYLineSeries) then
  begin
    Series := SelectedSeries as TXYLineSeries;
    Series.LinePen.Style := TPenStyle(LineStyleComboBox.ItemIndex);
  end;
end;

procedure TGraphEditDlg.LineWidthTrackBarChange(Sender: TObject);
var
  Series: TXYLineSeries;
  Value: Double;
begin
  if (SelectedSeries is TXYLineSeries) then
  begin
    Series := SelectedSeries as TXYLineSeries;
    with LineWidthTrackBar do
      Value := 0.25 * (1 + Position);
    Series.LineThickness := Trunc(100 * Value)/100;
    LabelLineWidth.Caption := FloatToStr(Value) + ' pt';
  end;
end;

{}[J[V[g̐ݒ}
procedure TGraphEditDlg.MarkerSettings;
var
  Series: TXYMarkerSeries;
begin
  if SelectedSeries is TXYMarkerSeries then
  begin
    Series :=  SelectedSeries as TXYMarkerSeries;
    MarkerActiveCheck.Checked := Series.Active;
    MarkerSizeEdit.Visible := Series.Active;
    MarkerJoinedCheck.Visible := Series.Active;
    MarkerShapeComboBox.Visible := Series.Active;
    MarkerSizeEdit.Value := Series.Marker.Size;
    MarkerJoinedCheck.Checked := Series.Joined;
    MarkerShapeComboBox.ItemIndex := Ord(Series.Marker.Shape);
    MarkerColorPicker.Selected := Series.Marker.Brush.Color;
  end;
end;

procedure TGraphEditDlg.MarkerShapeComboBoxChange(Sender: TObject);
var
  Series: TXYMarkerSeries;
begin
  if (SelectedSeries is TXYMarkerSeries) then
  begin
    Series :=  SelectedSeries as TXYMarkerSeries;
    Series.Marker.Shape := TMarkerShape(MarkerShapeComboBox.ItemIndex);
  end;
end;

procedure TGraphEditDlg.MarkerSizeEditChange(Sender: TObject);
var
  Series: TXYMarkerSeries;
begin
  if (SelectedSeries is TXYMarkerSeries) then
  begin
    Series :=  SelectedSeries as TXYMarkerSeries;
    Series.Marker.Size := MarkerSizeEdit.Value;
  end;
end;

procedure TGraphEditDlg.MarkerActiveCheckClick(Sender: TObject);
var
  Series: TXYMarkerSeries;
begin
  if (SelectedSeries is TXYMarkerSeries) then
  begin
    Series :=  SelectedSeries as TXYMarkerSeries;
    Series.Active := MarkerActiveCheck.Checked;
  end;
end;

procedure TGraphEditDlg.MarkerColorPickerSelect(Sender: TObject);
var
  Series: TXYMarkerSeries;
begin
  if (SelectedSeries is TXYMarkerSeries) then
  begin
    Series :=  SelectedSeries as TXYMarkerSeries;
    Series.Marker.Brush.Color := MarkerColorPicker.Selected;
  end;
end;

procedure TGraphEditDlg.MarkerJoinedCheckClick(Sender: TObject);
var
  Series: TXYMarkerSeries;
begin
  if (SelectedSeries is TXYMarkerSeries) then
  begin
    Series :=  SelectedSeries as TXYMarkerSeries;
    Series.Joined := MarkerJoinedCheck.Checked;
  end;
end;

{V[g̐ݒ}
procedure TGraphEditDlg.ArrowSettings;
var
  Series: TXYArrowSeries;
begin
  if SelectedSeries is TXYArrowSeries then
  begin
    Series :=  SelectedSeries as TXYArrowSeries;
    ArrowActiveCheck.Checked := Series.Active;
    ArrowSizeEdit.Enabled := Series.Active;
    ArrowSizeEdit.Value := Series.ArrowSize;
  end;
end;

procedure TGraphEditDlg.ArrowActiveCheckClick(Sender: TObject);
var
  Series: TXYArrowSeries;
begin
  if (SelectedSeries is TXYArrowSeries) then
  begin
    Series :=  SelectedSeries as TXYArrowSeries;
    Series.Active := ArrowActiveCheck.Checked;
  end;
end;

procedure TGraphEditDlg.ArrowSizeEditChange(Sender: TObject);
var
  Series: TXYArrowSeries;
begin
  if (SelectedSeries is TXYArrowSeries) then
  begin
    Series :=  SelectedSeries as TXYArrowSeries;
    Series.ArrowSize := ArrowSizeEdit.Value;
  end;
end;

{Ot̐ݒy[W̑Sʂƃ^Cg +@ڐ̎ނƏ}
procedure TGraphEditDlg.GraphSettings;
begin
  AutoAspectRatioCheck.Checked := Graph.AutoAspectRatio;
  GraphFrameCheck.Checked := Graph.Frame;
  GraphAreaColorPicker.Selected := Graph.Color;
  PlotAreaColorPicker.Selected := Graph.BackColor;
  case Graph.GridStyle of
    gsBoth:       BothGridButton.Down := True;
    gsHorizontal: HrznGridButton.Down := True;
    gsVertical:   VertGridButton.Down := True;
    gsNone:       NoGridButton.Down := True;
  end;
  SubGridCheck.Checked := Graph.SubGrid;
  if Graph.GridStyle = gsNone then
    SubGridCheck.Enabled := false;
  PiSymbolEdit.Text:=Graph.PiSymbol;
  TitleEdit.Text:=Graph.Title.Text;
  case Graph.TitleAlignment of
    taLeftJustify:  TitlePosGroup.ItemIndex := 0;
    taRightJustify: TitlePosGroup.ItemIndex := 2;
    taCenter:       TitlePosGroup.ItemIndex := 1;
  end;
end;

{AXyNg[h}
procedure TGraphEditDlg.AutoAspectRatioCheckClick(Sender: TObject);
begin
  Graph.AutoAspectRatio := AutoAspectRatioCheck.Checked;
end;

{t[ň͂ނ}
procedure TGraphEditDlg.GraphFrameCheckClick(Sender: TObject);
begin
  Graph.Frame := GraphFrameCheck.Checked;
end;

{OtGA̐F}
procedure TGraphEditDlg.GraphAreaColorPickerSelect(Sender: TObject);
begin
  Graph.Color := GraphAreaColorPicker.Selected;
end;

{vbgGA̐F}
procedure TGraphEditDlg.PlotAreaColorPickerSelect(Sender: TObject);
begin
  Graph.BackColor := PlotAreaColorPicker.Selected;

end;

{ڐ̐ݒ}
procedure TGraphEditDlg.BothGridButtonClick(Sender: TObject);
begin
  if BothGridButton.Down then
  begin
    SubGridCheck.Enabled := true;
    Graph.GridStyle := gsBoth;
  end;
end;

procedure TGraphEditDlg.HrznGridButtonClick(Sender: TObject);
begin
  if HrznGridButton.Down then
  begin
    SubGridCheck.Enabled := true;
    Graph.GridStyle := gsHorizontal;
  end;
end;

procedure TGraphEditDlg.VertGridButtonClick(Sender: TObject);
begin
  if VertGridButton.Down then
  begin
    SubGridCheck.Enabled := true;
    Graph.GridStyle := gsVertical;
  end;
end;

procedure TGraphEditDlg.NoGridButtonClick(Sender: TObject);
begin
  if NoGridButton.Down then
  begin
    SubGridCheck.Checked := false;
    SubGridCheck.Enabled := false;
    Graph.GridStyle := gsNone;
  end;
end;

{ڐ̐ݒ}
procedure TGraphEditDlg.SubGridCheckClick(Sender: TObject);
begin
  Graph.SubGrid := SubGridCheck.Checked;
end;

{^Cg}
procedure TGraphEditDlg.TitleFontBtnClick(Sender: TObject);
begin
  FontDialog.Font:=Graph.TitleFont;
  if FontDialog.Execute then
    Graph.TitleFont:=FontDialog.Font;
  UpdateAxisScale;
end;

procedure TGraphEditDlg.TitleEditChange(Sender: TObject);
begin
  Graph.Title.Assign(TitleEdit.Lines);
  UpdateAxisScale;
end;

procedure TGraphEditDlg.TitlePosGroupClick(Sender: TObject);
begin
  case TitlePosGroup.ItemIndex of
    0:begin
        TitleEdit.Alignment:=taLeftJustify;
        Graph.TitleAlignment:=taLeftJustify;
      end;
    1:begin
        TitleEdit.Alignment:=taCenter;
        Graph.TitleAlignment:=taCenter;
      end;
    2:begin
        TitleEdit.Alignment:=taRightJustify;
        Graph.TitleAlignment:=taRightJustify;
      end;
  end;
end;

procedure TGraphEditDlg.PiSymbolEditChange(Sender: TObject);
begin
  Graph.PiSymbol:=PiSymbolEdit.Text;
  UpdateAxisScale;
end;

procedure TGraphEditDlg.PiSymbolBtnClick(Sender: TObject);
begin
  if FontDialog.Execute then
  begin
    Graph.TitleFont:=FontDialog.Font;
    UpdateAxisScale;
  end;
end;

{̃y[W}
procedure TGraphEditDlg.AxesSelectGroupClick(Sender: TObject);
begin
  if CurrAxisIndex <> AxesSelectGroup.ItemIndex then
  begin
    CurrAxisIndex := AxesSelectGroup.ItemIndex;
    if CurrAxisIndex = 0 then
      CurrAxis := Graph.XAxis
    else
      CurrAxis := Graph.YAxis;
  end;
  AxisSettings;
  AxisLineSetting;
end;

procedure TGraphEditDlg.AxisVisibleCheckClick(Sender: TObject);
begin
  CurrAxis.Visible:=AxisVisibleCheck.Checked;
  UpdateAxisScale;
end;

{̖ڐy[W}
{̍ŏl}
procedure TGraphEditDlg.AxisMinCheckClick(Sender: TObject);
begin
  CurrAxis.AutoMin:=AxisMinCheck.Checked;
  UpdateAxisScale;
end;

procedure TGraphEditDlg.AxisMinEditEnter(Sender: TObject);
begin
  AxisMinEdit.SelectAll;
  TempText:=AxisMinEdit.Text;
end;

procedure TGraphEditDlg.AxisMinEditExit(Sender: TObject);
var
  Temp, OldMin: double;
begin
  OldMin := CurrAxis.Min;
  if AxisMinEdit.Modified then
    try
      Temp:=StrToFloat(AxisMinEdit.Text);
      if CurrAxis.AxisScale = asPi then
        CurrAxis.Min:= Temp*Pi else  CurrAxis.Min:=Temp;
      UpdateAxisScale;
    except
      CurrAxis.Min:= OldMin;
      AxisMinEdit.Text:=TempText;
      raise;
    end;
end;

{̍ől}
procedure TGraphEditDlg.AxisMaxCheckClick(Sender: TObject);
begin
  CurrAxis.AutoMax:=AxisMaxCheck.Checked;
  UpdateAxisScale;
end;

procedure TGraphEditDlg.AxisMaxEditEnter(Sender: TObject);
begin
  AxisMaxEdit.SelectAll;
  TempText:=AxisMaxEdit.Text;
end;

procedure TGraphEditDlg.AxisMaxEditExit(Sender: TObject);
var
  Temp, OldMax: double;
begin
  OldMax := CurrAxis.Max;
  if AxisMaxEdit.Modified then
    try
      Temp:=StrToFloat(AxisMaxEdit.Text);
      if CurrAxis.AxisScale = asPi then
        CurrAxis.Max:= Temp*Pi else  CurrAxis.Max:=Temp;
      UpdateAxisScale;
    except
      CurrAxis.Max:= OldMax;
      AxisMaxEdit.Text:=TempText;
      raise;
    end;
end;

{̖ڐԊu}
procedure TGraphEditDlg.AxisStepCheckClick(Sender: TObject);
begin
  CurrAxis.AutoStep:=AxisStepCheck.Checked;
  UpdateAxisScale;
end;

procedure TGraphEditDlg.AxisStepEditEnter(Sender: TObject);
begin
  AxisStepEdit.SelectAll;
  TempText:=AxisStepEdit.Text;
end;

procedure TGraphEditDlg.AxisStepEditExit(Sender: TObject);
var
  Temp: double;
begin
  if AxisStepEdit.Modified then
    try
      Temp:=StrToFloat(AxisStepEdit.Text);
      if CurrAxis.AxisScale = asPi then
        CurrAxis.TickStep:= Temp*Pi else  CurrAxis.TickStep:=Temp;
       UpdateAxisScale;
    except
      AxisStepEdit.Text:=TempText;
      raise;
    end;
end;

{̌_}
procedure TGraphEditDlg.AxisOriginCheckClick(Sender: TObject);
begin
  CurrAxis.AutoOrigin:=AxisOriginCheck.Checked;
  UpdateAxisScale;
end;

procedure TGraphEditDlg.AxisOriginEditEnter(Sender: TObject);
begin
  AxisOriginEdit.SelectAll;
  TempText:=AxisOriginEdit.Text;
end;

procedure TGraphEditDlg.AxisOriginEditExit(Sender: TObject);
var
  Temp: double;
begin
  if AxisOriginEdit.Modified then
    try
      Temp:=StrToFloat(AxisOriginEdit.Text);
      if CurrAxis.AxisScale = asPi then
        CurrAxis.Origin:= Temp*Pi
      else
        CurrAxis.Origin:=Temp;
      UpdateAxisScale;
    except
      AxisOriginEdit.Text:=TempText;
      raise;
    end;
end;

{ΖڐAΐڐ̐ݒ}
procedure TGraphEditDlg.AxisScaleComboChange(Sender: TObject);
var
  TempIndex: integer;
begin
  TempIndex:=Ord(CurrAxis.AxisScale);
  try
    with CurrAxis do
      case AxisScaleCombo.ItemIndex of
        0: AxisScale:=asNormal;
        1: AxisScale:=asPi;
        2: AxisScale:=asPercent;
        3: AxisScale:=asLog;
      end;
    UpdateAxisScale;
  except
    AxisScaleCombo.ItemIndex:=TempIndex;
    raise;
  end;
end;

procedure TGraphEditDlg.AxisInverseCheckClick(Sender: TObject);
begin
  CurrAxis.Inverted:=AxisInverseCheck.Checked;
  UpdateAxisScale;
end;

procedure TGraphEditDlg.AxisSubTicksCountEditChange(Sender: TObject);
begin
  CUrrAxis.SubTicksCount:=AxisSubTicksCountEdit.Value;
end;

procedure TGraphEditDlg.AxisSubTicksCountEditClick(Sender: TObject);
begin
end;

{xy[W}
procedure TGraphEditDlg.AxisLabelVisibleCheckClick(Sender: TObject);
begin
  AxisLabelOnAxisCheck.Enabled:=AxisLabelVisibleCheck.Checked;
  CurrAxis.Labels:=AxisLabelVisibleCheck.Checked;
  AxisSettings;
end;

procedure TGraphEditDlg.AxisLabelOnAxisCheckClick(Sender: TObject);
begin
  CurrAxis.LabelsOnAxis:=AxisLabelOnAxisCheck.Checked;
  UpdateAxisScale;
end;

procedure TGraphEditDlg.AxisAutoDecimalCheckClick(Sender: TObject);
begin
  CurrAxis.AutoDecimal:=AxisAutoDecimalCheck.Checked;
  AxisSettings;
end;

procedure TGraphEditDlg.AxisLabelDecEditChange(Sender: TObject);
begin
  CurrAxis.LabelDecimal:=AxisLabelDecEdit.Value;
  AxisSettings;
end;

procedure TGraphEditDlg.AxisTicksCountEditChange(Sender: TObject);
begin
  CurrAxis.TicksCount:=AxisTicksCountEdit.Value;
  UpdateAxisScale;
  //AxisSettings;
end;

procedure TGraphEditDlg.AxisLabelSpaceEditChange(Sender: TObject);
begin
  CurrAxis.LabelSpace:=AxisLabelSpaceEdit.Value;
  UpdateAxisScale;
end;

procedure TGraphEditDlg.AxisLabelFontBtnClick(Sender: TObject);
begin
  FontDialog.Font:=CurrAxis.LabelFont;
  if FontDialog.Execute then
  begin
    CurrAxis.LabelFont:=FontDialog.Font;
    UpdateAxisScale;
  end;
end;

{^Cgy[W}
procedure TGraphEditDlg.AxisTitleEditChange(Sender: TObject);
begin
  CurrAxis.Title:=AxisTitleEdit.Text;
  UpdateAxisScale;
end;

procedure TGraphEditDlg.AxisTitleLocComboChange(Sender: TObject);
begin
  with CurrAxis do
    case AxisTitleLocCombo.ItemIndex of
      0:AxisTitleLoc:=tlHead;
      1:AxisTitleLoc:=tlFoot;
      2:AxisTitleLoc:=tlSide;
      3:AxisTitleLoc:=tlFixed;
    end;
  UpdateAxisScale;
end;

procedure TGraphEditDlg.AxisTitleFontBtnClick(Sender: TObject);
begin
  FontDialog.Font:=CurrAxis.TitleFont;
  if FontDialog.Execute then
  begin
    CurrAxis.TitleFont:=FontDialog.Font;
    UpdateAxisScale;
  end;
end;

procedure TGraphEditDlg.AxisTitleAngleComboChange(Sender: TObject);
begin
  with CurrAxis do
    case AxisTitleAngleCombo.ItemIndex of
      0:TitleAngle := 0;
      1:TitleAngle := 90;
      2:TitleAngle := 180;
      3:TitleAngle := 270;
    end;
  UpdateAxisScale;
end;

procedure TGraphEditDlg.AxisTickLenEditChange(Sender: TObject);
begin
  CurrAxis.TickLen:=AxisTickLenEdit.Value;
  UpdateAxisScale;
end;

procedure TGraphEditDlg.AxisSubTickLenEditChange(Sender: TObject);
begin
  CurrAxis.SubTickLen:=AxisSubTickLenEdit.Value;
  UpdateAxisScale;
end;

procedure TGraphEditDlg.AxisExtraLenEditChange(Sender: TObject);
begin
  CurrAxis.ExtraLen:=AxisExtraLenEdit.Value;
  UpdateAxisScale;
end;

{̕ҏW}
procedure TGraphEditDlg.AxisLineSetting;
var
  Value: Single;
begin
  CurrAxisIndex := AxesSelectGroup.ItemIndex;
  CurrPen := GetCurrAxisPen(CurrAxisIndex);
  with CurrPen do
  begin
    AxislineColorPicker.Selected := Color;
    AxislineComboBox.ItemIndex := Integer(Style);
  end;
  case CurrAxisIndex of
    0: Value := 4 * Graph.XAxis.LineThickness -1;
    1: Value := 4 * Graph.YAxis.LineThickness -1;
  end;
  with AxisLineTrackBar do
  begin
    if Value > Max then Value := Max;
    if Value < Min then Value := Min;
    Position := Trunc(Value);
  end;
  LabelAxisWidth.Caption := FloatToStr((Value + 1)/4 ) + ' pt';
end;

procedure TGraphEditDlg.AxisLineColorPickerSelect(Sender: TObject);
begin
  case CurrAxisIndex of
    0: Graph.XAxis.AxisPen.Color := AxislineColorPicker.Selected;
    1: Graph.YAxis.AxisPen.Color := AxislineColorPicker.Selected;
  end;
end;

procedure TGraphEditDlg.AxisLineComboBoxSelect(Sender: TObject);
begin
  case CurrAxisIndex of
    0: Graph.XAxis.AxisPen.Style := TPenStyle(GridlineComboBox.ItemIndex);
    1: Graph.YAxis.AxisPen.Style := TPenStyle(GridlineComboBox.ItemIndex);
  end;
end;

procedure TGraphEditDlg.AxisLineTrackBarChange(Sender: TObject);
var
  Value: Double;
begin
  with AxisLineTrackBar do
    Value := 0.25 * (1 + Position);
  Value := Trunc(100 * Value)/100;
  case CurrAxisIndex of
    0: Graph.XAxis.LineThickness := Value;
    1: Graph.YAxis.LineThickness := Value;
  end;
  LabelAxisWidth.Caption := FloatToStr(Value) + ' pt';
end;

function TGraphEditDlg.GetCurrAxisPen(Index: Integer): TPen;
begin
  case Index of
    0: Result := Graph.XAxis.AxisPen;
    1: Result := Graph.YAxis.AxisPen;
  end;
end;

function TGraphEditDlg.GetCurrGridlinePen(Index: Integer): TPen;
begin
  case Index of
    0: Result := Graph.GridPen;
    1: Result := Graph.SubGridPen;
  end;
end;

procedure TGraphEditDlg.GridlineColorPickerSelect(Sender: TObject);
begin
  case CurrGridlineIndex of
    0: Graph.GridPen.Color := GridlineColorPicker.Selected;
    1: Graph.SubGridPen.Color := GridlineColorPicker.Selected;
  end;
end;

procedure TGraphEditDlg.GridlineComboBoxSelect(Sender: TObject);
begin
  case CurrGridlineIndex of
    0: Graph.GridPen.Style := TPenStyle(GridlineComboBox.ItemIndex);
    1: Graph.SubGridPen.Style := TPenStyle(GridlineComboBox.ItemIndex);
  end;
end;

procedure TGraphEditDlg.GridlineSelectGroupClick(Sender: TObject);
begin
  GridlineSetting;
end;

procedure TGraphEditDlg.GridlineSetting;
var
  Value: Single;
begin
  CurrGridlineIndex := GridlineSelectGroup.ItemIndex;
  CurrPen := GetCurrGridlinePen(CurrGridlineIndex);
  with CurrPen do
  begin
    GridlineColorPicker.Selected := Color;
    GridlineComboBox.ItemIndex := Integer(Style);
  end;
  case CurrGridlineIndex of
    0: Value := 4 * Graph.GridThickness -1;
    1: Value := 4 * Graph.SubGridThickness -1;
  end;
  with GridLineTrackBar do
  begin
    if Value > Max then Value := Max;
    if Value < Min then Value := Min;
    Position := Trunc(Value);
  end;
  LabelGridlineWidth.Caption := FloatToStr((Value + 1)/4 ) + ' pt';
end;

procedure TGraphEditDlg.GridlineTrackBarChange(Sender: TObject);
var
  Value: Double;
begin
  with GridlineTrackBar do
    Value := 0.25 * (1 + Position);
  Value := Trunc(100 * Value)/100;
  case CurrGridLineIndex of
    0: Graph.GridThickness := Value;
    1: Graph.SubGridThickness := Value;
  end;
  LabelGridlineWidth.Caption := FloatToStr(Value) + ' pt';
end;

end.
