unit GPXYSeriesDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,
  GPXYGraph, GPXYSeries;

type
  TSeriesSelectDlg = class(TForm)
    OKButton: TButton;
    CancelButton: TButton;
    SelectListBox: TListBox;
    procedure OKButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SelectListBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure CancelButtonClick(Sender: TObject);
  private
    { Private 錾 }
    procedure AddSeriesClasses(ATitle: string; ASeriesClass: TGPXYGraphSeriesClass);
  public
    { Public 錾 }
    function SelectedSeriesClass: TGPXYGraphSeriesClass;
  end;


implementation

{$R *.DFM}

procedure TSeriesSelectDlg.FormCreate(Sender: TObject);
begin
  EnumXYGraphSeries(AddSeriesClasses);
  if SelectListBox.Items.Count > 0 then
    SelectListBox.ItemIndex := 0;
end;

procedure TSeriesSelectDlg.OKButtonClick(Sender: TObject);
begin
  ModalResult := mrOK;
end;

procedure TSeriesSelectDlg.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TSeriesSelectDlg.AddSeriesClasses(ATitle: string; ASeriesClass: TGPXYGraphSeriesClass);
begin
  SelectListBox.Items.AddObject(ATitle, TObject(ASeriesClass));
end;

function TSeriesSelectDlg.SelectedSeriesClass: TGPXYGraphSeriesClass;
begin
  with SelectListBox do
  begin
    if ItemIndex >= 0 then
      Result := TGPXYGraphSeriesClass(Items.Objects[ItemIndex])
    else
      Result := nil;
  end;
end;

procedure TSeriesSelectDlg.SelectListBoxDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  Bitmap: TBitmap;
  Offset: Integer;
  Series: TGPXYGraphSeriesClass;
begin
  with SelectListBox.Canvas do  { Rg[̃LoXɕ`}
  begin
    FillRect(Rect);
    Offset := 2;
    Bitmap := TBitmap.Create;
    try
      Series := GetXYGraphSeriesClass(SelectListBox.Items[Index]);
      if Series <> nil then
      begin
        Bitmap.LoadFromResourceName(hInstance, Series.ClassName);
        if Bitmap <> nil then
        begin
          BrushCopy(Bounds(Rect.Left + 2, Rect.Top, Bitmap.Width, Bitmap.Height),
	    	  Bitmap, Bounds(0, 0, Bitmap.Width, Bitmap.Height), clSilver);
           { rbg}bvƕ̊Ԃ 4 sNZǉ }
          Offset := Bitmap.width + 6;
        end;
      end;
    finally
      Bitmap.Free;
    end;
    TextOut(Rect.Left + Offset, Rect.Top, SelectListBox.Items[Index]);
  end;
end;

end.
